Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Creators/ProbabilisticTreeCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Creators/ProbabilisticTreeCreator.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Creators/ProbabilisticTreeCreator.cs	(revision 3338)
@@ -27,4 +27,6 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using System.Collections.Generic;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols;
+using System.Text;
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
@@ -32,13 +34,21 @@
   [Item("ProbabilisticTreeCreator", "An operator that creates new symbolic expression trees with uniformly distributed size")]
   public class ProbabilisticTreeCreator : SymbolicExpressionTreeCreator {
+
     public ProbabilisticTreeCreator()
       : base() {
     }
 
-    protected override SymbolicExpressionTree Create(IRandom random, ISymbolicExpressionGrammar grammar, IntValue maxTreeSize, IntValue maxTreeHeight) {
-      return Create(random, grammar, maxTreeSize.Value, maxTreeHeight.Value);
-    }
-
-    public static SymbolicExpressionTree Create(IRandom random, ISymbolicExpressionGrammar grammar, int maxTreeSize, int maxTreeHeight) {
+    protected override SymbolicExpressionTree Create(
+      IRandom random,
+      ISymbolicExpressionGrammar grammar,
+      IntValue maxTreeSize, IntValue maxTreeHeight,
+      IntValue maxFunctionDefinitions, IntValue maxFunctionArguments) {
+      return Create(random, grammar, maxTreeSize.Value, maxTreeHeight.Value, maxFunctionDefinitions.Value, maxFunctionArguments.Value);
+    }
+
+    public static SymbolicExpressionTree Create(IRandom random, ISymbolicExpressionGrammar grammar,
+      int maxTreeSize, int maxTreeHeight,
+      int maxFunctionDefinitions, int maxFunctionArguments
+      ) {
       // tree size is limited by the grammar and by the explicit size constraints
       int allowedMinSize = grammar.GetMinExpressionLength(grammar.StartSymbol);
@@ -49,6 +59,5 @@
       do {
         try {
-          tree.Root = grammar.ProgramRootSymbol.CreateTreeNode();
-          tree.Root.AddSubTree(PTC2(random, grammar, grammar.StartSymbol, treeSize + 1, maxTreeHeight + 1));
+          tree.Root = PTC2(random, grammar, grammar.StartSymbol, treeSize + 1, maxTreeHeight + 1, maxFunctionDefinitions, maxFunctionArguments);
         }
         catch (ArgumentException) {
@@ -56,6 +65,199 @@
           treeSize = random.Next(allowedMinSize, allowedMaxSize);
         }
-      } while (tree.Root.SubTrees.Count == 0 || tree.Size > maxTreeSize || tree.Height > maxTreeHeight);
+      } while (tree.Root == null || tree.Size > maxTreeSize || tree.Height > maxTreeHeight);
       return tree;
+    }
+
+    private class TreeExtensionPoint {
+      public SymbolicExpressionTreeNode Parent { get; set; }
+      public int ChildIndex { get; set; }
+      public int ExtensionPointDepth { get; set; }
+    }
+    public static SymbolicExpressionTreeNode PTC2(IRandom random, ISymbolicExpressionGrammar grammar, Symbol rootSymbol,
+      int size, int maxDepth, int maxFunctionDefinitions, int maxFunctionArguments) {
+      SymbolicExpressionTreeNode root = rootSymbol.CreateTreeNode();
+      root.Grammar = grammar;
+      if (size <= 1 || maxDepth <= 1) return root;
+      CreateFullTreeFromSeed(random, root, size, maxDepth, maxFunctionDefinitions, maxFunctionArguments);
+      return root;
+    }
+
+    private static void CreateFullTreeFromSeed(IRandom random, SymbolicExpressionTreeNode root, int size, int maxDepth, int maxFunctionDefinitions, int maxFunctionArguments) {
+      List<TreeExtensionPoint> extensionPoints = new List<TreeExtensionPoint>();
+      int currentSize = 1;
+      int totalListMinSize = root.Grammar.GetMinExpressionLength(root.Symbol) - 1;
+      int actualArity = SampleArity(random, root, size);
+      for (int i = 0; i < actualArity; i++) {
+        // insert a dummy sub-tree and add the pending extension to the list
+        var dummy = new SymbolicExpressionTreeNode();
+        root.AddSubTree(dummy);
+        dummy.Grammar = (ISymbolicExpressionGrammar)dummy.Grammar.Clone();
+        extensionPoints.Add(new TreeExtensionPoint { Parent = root, ChildIndex = i, ExtensionPointDepth = 2 });
+      }
+      // while there are pending extension points and we have not reached the limit of adding new extension points
+      while (extensionPoints.Count > 0 && totalListMinSize + currentSize < size) {
+        int randomIndex = random.Next(extensionPoints.Count);
+        TreeExtensionPoint nextExtension = extensionPoints[randomIndex];
+        extensionPoints.RemoveAt(randomIndex);
+        SymbolicExpressionTreeNode parent = nextExtension.Parent;
+        int argumentIndex = nextExtension.ChildIndex;
+        int extensionDepth = nextExtension.ExtensionPointDepth;
+        if (extensionDepth + parent.Grammar.GetMinExpressionDepth(parent.Symbol) >= maxDepth) {
+          ReplaceWithMinimalTree(random, root, parent, argumentIndex, maxFunctionDefinitions, maxFunctionArguments);
+          //parent.RemoveSubTree(argumentIndex);
+          //var allowedSymbols = from s in parent.Grammar.Symbols
+          //                     where parent.Grammar.IsAllowedChild(parent.Symbol, s, argumentIndex)
+          //                     select s;
+          //SymbolicExpressionTreeNode branch = CreateMinimalTree(random, parent, allowedSymbols);
+          //parent.InsertSubTree(argumentIndex, branch); // insert a smallest possible tree
+          //currentSize += branch.GetSize();
+          //totalListMinSize -= branch.GetSize();
+        } else {
+          var allowedSymbols = from s in parent.Grammar.Symbols
+                               where parent.Grammar.IsAllowedChild(parent.Symbol, s, argumentIndex)
+                               where parent.Grammar.GetMinExpressionDepth(s) + extensionDepth - 1 < maxDepth
+                               where parent.Grammar.GetMaxExpressionLength(s) > size - totalListMinSize - currentSize
+                               /*||
+                                     totalListMinSize + currentSize >= size * 0.9 // if the necessary size is almost reached then also allow
+                               // terminals or terminal-branches*/
+                               // where !IsDynamicSymbol(s) || IsDynamicSymbolAllowed(grammar, root, parent, s)
+                               select s;
+          Symbol selectedSymbol = SelectRandomSymbol(random, allowedSymbols);
+          SymbolicExpressionTreeNode newTree = selectedSymbol.CreateTreeNode();
+          parent.RemoveSubTree(argumentIndex);
+          parent.InsertSubTree(argumentIndex, newTree);
+
+          InitializeNewTreeNode(random, root, newTree, maxFunctionDefinitions, maxFunctionArguments);
+
+          currentSize++;
+          totalListMinSize--;
+
+          actualArity = SampleArity(random, newTree, size - currentSize);
+          for (int i = 0; i < actualArity; i++) {
+            // insert a dummy sub-tree and add the pending extension to the list
+            var dummy = new SymbolicExpressionTreeNode();
+            newTree.AddSubTree(dummy);
+            if (IsTopLevelBranch(root, dummy))
+              dummy.Grammar = (ISymbolicExpressionGrammar)dummy.Grammar.Clone();
+            extensionPoints.Add(new TreeExtensionPoint { Parent = newTree, ChildIndex = i, ExtensionPointDepth = extensionDepth + 1 });
+          }
+          totalListMinSize += newTree.Grammar.GetMinExpressionLength(newTree.Symbol);
+        }
+      }
+      // fill all pending extension points
+      while (extensionPoints.Count > 0) {
+        int randomIndex = random.Next(extensionPoints.Count);
+        TreeExtensionPoint nextExtension = extensionPoints[randomIndex];
+        extensionPoints.RemoveAt(randomIndex);
+        SymbolicExpressionTreeNode parent = nextExtension.Parent;
+        int a = nextExtension.ChildIndex;
+        int d = nextExtension.ExtensionPointDepth;
+        ReplaceWithMinimalTree(random, root, parent, a, maxFunctionDefinitions, maxFunctionArguments);
+      }
+    }
+
+    private static void ReplaceWithMinimalTree(IRandom random, SymbolicExpressionTreeNode root, SymbolicExpressionTreeNode parent, int argumentIndex, int maxFunctionDefinitions, int maxFunctionArguments) {
+      // determine possible symbols that will lead to the smallest possible tree
+      var possibleSymbols = (from s in parent.GetAllowedSymbols(argumentIndex)
+                             group s by parent.Grammar.GetMinExpressionLength(s) into g
+                             orderby g.Key
+                             select g).First();
+      var selectedSymbol = SelectRandomSymbol(random, possibleSymbols);
+      var tree = selectedSymbol.CreateTreeNode();
+      parent.RemoveSubTree(argumentIndex);
+      parent.InsertSubTree(argumentIndex, tree);
+      InitializeNewTreeNode(random, root, tree, maxFunctionDefinitions, maxFunctionArguments);
+      for (int i = 0; i < tree.GetMinSubtreeCount(); i++) {
+        // insert a dummy sub-tree and add the pending extension to the list
+        var dummy = new SymbolicExpressionTreeNode();
+        tree.AddSubTree(dummy);
+        dummy.Grammar = (ISymbolicExpressionGrammar)dummy.Grammar.Clone(); 
+        // replace the just inserted dummy by recursive application
+        ReplaceWithMinimalTree(random, root, tree, i, maxFunctionDefinitions, maxFunctionArguments);
+      }
+    }
+   
+    private static void InitializeNewTreeNode(IRandom random, SymbolicExpressionTreeNode root, SymbolicExpressionTreeNode newTree, int maxFunctionDefinitions, int maxFunctionArguments) {
+      // NB it is assumed that defuns are only allowed as children of root and nowhere else
+      // also assumes that newTree is already attached to root somewhere
+      if (IsTopLevelBranch(root, newTree))
+        newTree.Grammar = (ISymbolicExpressionGrammar)newTree.Grammar.Clone();
+      if (newTree.Symbol is Defun) {
+        var defunTree = newTree as DefunTreeNode;
+        string formatString = new StringBuilder().Append('0', (int)Math.Log10(maxFunctionDefinitions * 10 - 1)).ToString(); // >= 100 functions => ###
+        var allowedNames = from index in Enumerable.Range(0, maxFunctionDefinitions)
+                           select "ADF" + index.ToString(formatString);
+        var takenNames = (from node in root.IterateNodesPrefix().OfType<DefunTreeNode>()
+                          select node.FunctionName).Distinct();
+        var remainingNames = allowedNames.Except(takenNames).ToList();
+        string functionName = remainingNames[random.Next(remainingNames.Count)];
+        // set name and number of arguments of the ADF
+        int nArgs = random.Next(maxFunctionArguments);
+        defunTree.FunctionName = functionName;
+        defunTree.NumberOfArguments = nArgs;
+        if (nArgs > 0) {
+          AddDynamicArguments(defunTree.Grammar, nArgs);
+        }
+        int argIndex = root.SubTrees.IndexOf(newTree);
+        // allow invokes of ADFs with higher index
+        for (int i = argIndex + 1; i < root.SubTrees.Count; i++) {
+          var otherDefunNode = root.SubTrees[i] as DefunTreeNode;
+          if (otherDefunNode != null) {
+            var allowedParents = from sym in defunTree.Grammar.Symbols
+                                 where defunTree.Grammar.IsAllowedChild(defunTree.Symbol, sym, 0)
+                                 select sym;
+            var allowedChildren = allowedParents;
+            AddDynamicSymbol(defunTree.Grammar, allowedParents, allowedChildren, otherDefunNode.FunctionName, otherDefunNode.NumberOfArguments);
+          }
+        }
+        // make the ADF available as symbol for other branches (with smaller index to prevent recursions)
+        for (int i = 0; i < argIndex; i++) {
+          // if not dummy node
+          if (root.SubTrees[i].Symbol != null) {
+            var topLevelGrammar = root.SubTrees[i].Grammar;
+            var allowedParents = from sym in root.SubTrees[i].Grammar.Symbols
+                                 where root.SubTrees[i].Grammar.IsAllowedChild(root.SubTrees[i].Symbol, sym, 0)
+                                 select sym;
+            var allowedChildren = allowedParents;
+
+            AddDynamicSymbol(topLevelGrammar, allowedParents, allowedChildren, functionName, nArgs);
+          }
+        }
+      }
+    }
+
+    private static void AddDynamicSymbol(ISymbolicExpressionGrammar grammar, IEnumerable<Symbol> allowedParents, IEnumerable<Symbol> allowedChildren, string symbolName, int nArgs) {
+      var invokeSym = new InvokeFunction(symbolName);
+      grammar.AddSymbol(invokeSym);
+      grammar.SetMinSubtreeCount(invokeSym, nArgs);
+      grammar.SetMaxSubtreeCount(invokeSym, nArgs);
+      foreach (var parent in allowedParents) {
+        for (int arg = 0; arg < grammar.GetMaxSubtreeCount(parent); arg++) {
+          grammar.SetAllowedChild(parent, invokeSym, arg);
+        }
+      }
+      foreach (var child in allowedChildren) {
+        for (int arg = 0; arg < grammar.GetMaxSubtreeCount(invokeSym); arg++) {
+          grammar.SetAllowedChild(invokeSym, child, arg);
+        }
+      }
+    }
+
+    private static void AddDynamicArguments(ISymbolicExpressionGrammar grammar, int nArgs) {
+      for (int argIndex = 0; argIndex < nArgs; argIndex++) {
+        var argNode = new Argument(argIndex);
+        grammar.AddSymbol(argNode);
+        grammar.SetMinSubtreeCount(argNode, 0);
+        grammar.SetMaxSubtreeCount(argNode, 0);
+        // allow the argument as child of any other symbol
+        foreach (var symb in grammar.Symbols)
+          for (int i = 0; i < grammar.GetMaxSubtreeCount(symb); i++) {
+            grammar.SetAllowedChild(symb, argNode, i);
+          }
+      }
+    }
+
+    private static bool IsTopLevelBranch(SymbolicExpressionTreeNode root, SymbolicExpressionTreeNode branch) {
+      return root.SubTrees.IndexOf(branch) > -1;
     }
 
@@ -75,75 +277,8 @@
     }
 
-
-    public static SymbolicExpressionTreeNode PTC2(IRandom random, ISymbolicExpressionGrammar grammar, Symbol rootSymbol, int size, int maxDepth) {
-      SymbolicExpressionTreeNode root = rootSymbol.CreateTreeNode();
-      if (size <= 1 || maxDepth <= 1) return root;
-      List<object[]> extensionPoints = new List<object[]>();
-      int currentSize = 1;
-      int totalListMinSize = grammar.GetMinExpressionLength(rootSymbol) - 1;
-
-      int actualArity = SampleArity(random, grammar, rootSymbol, size);
-      for (int i = 0; i < actualArity; i++) {
-        // insert a dummy sub-tree and add the pending extension to the list
-        root.AddSubTree(null);
-        extensionPoints.Add(new object[] { root, i, 2 });
-      }
-
-      // while there are pending extension points and we have not reached the limit of adding new extension points
-      while (extensionPoints.Count > 0 && totalListMinSize + currentSize < size) {
-        int randomIndex = random.Next(extensionPoints.Count);
-        object[] nextExtension = extensionPoints[randomIndex];
-        extensionPoints.RemoveAt(randomIndex);
-        SymbolicExpressionTreeNode parent = (SymbolicExpressionTreeNode)nextExtension[0];
-        int argumentIndex = (int)nextExtension[1];
-        int extensionDepth = (int)nextExtension[2];
-        if (extensionDepth + grammar.GetMinExpressionDepth(parent.Symbol) >= maxDepth) {
-          parent.RemoveSubTree(argumentIndex);
-          SymbolicExpressionTreeNode branch = CreateMinimalTree(random, grammar, grammar.GetAllowedSymbols(parent.Symbol, argumentIndex));
-          parent.InsertSubTree(argumentIndex, branch); // insert a smallest possible tree
-          currentSize += branch.GetSize();
-          totalListMinSize -= branch.GetSize();
-        } else {
-          var allowedSubFunctions = from s in grammar.GetAllowedSymbols(parent.Symbol, argumentIndex)
-                                    where grammar.GetMinExpressionDepth(parent.Symbol) + extensionDepth - 1 < maxDepth
-                                    where grammar.GetMaxExpressionLength(s) > size - totalListMinSize - currentSize ||
-                                          totalListMinSize + currentSize >= size * 0.9 // if the necessary size is almost reached then also allow
-                                    // terminals or terminal-branches
-                                    select s;
-          Symbol selectedSymbol = SelectRandomSymbol(random, allowedSubFunctions);
-          SymbolicExpressionTreeNode newTree = selectedSymbol.CreateTreeNode();
-          parent.RemoveSubTree(argumentIndex);
-          parent.InsertSubTree(argumentIndex, newTree);
-          currentSize++;
-          totalListMinSize--;
-
-          actualArity = SampleArity(random, grammar, selectedSymbol, size - currentSize);
-          for (int i = 0; i < actualArity; i++) {
-            // insert a dummy sub-tree and add the pending extension to the list
-            newTree.AddSubTree(null);
-            extensionPoints.Add(new object[] { newTree, i, extensionDepth + 1 });
-          }
-          totalListMinSize += grammar.GetMinExpressionLength(selectedSymbol);
-        }
-      }
-      // fill all pending extension points
-      while (extensionPoints.Count > 0) {
-        int randomIndex = random.Next(extensionPoints.Count);
-        object[] nextExtension = extensionPoints[randomIndex];
-        extensionPoints.RemoveAt(randomIndex);
-        SymbolicExpressionTreeNode parent = (SymbolicExpressionTreeNode)nextExtension[0];
-        int a = (int)nextExtension[1];
-        int d = (int)nextExtension[2];
-        parent.RemoveSubTree(a);
-        parent.InsertSubTree(a,
-          CreateMinimalTree(random, grammar, grammar.GetAllowedSymbols(parent.Symbol, a))); // append a tree with minimal possible height
-      }
-      return root;
-    }
-
-    private static int SampleArity(IRandom random, ISymbolicExpressionGrammar grammar, Symbol symbol, int targetSize) {
+    private static int SampleArity(IRandom random, SymbolicExpressionTreeNode node, int targetSize) {
       // select actualArity randomly with the constraint that the sub-trees in the minimal arity can become large enough
-      int minArity = grammar.GetMinSubTreeCount(symbol);
-      int maxArity = grammar.GetMaxSubTreeCount(symbol);
+      int minArity = node.GetMinSubtreeCount();
+      int maxArity = node.GetMaxSubtreeCount();
       if (maxArity > targetSize) {
         maxArity = targetSize;
@@ -153,6 +288,6 @@
       long aggregatedLongestExpressionLength = 0;
       for (int i = 0; i < maxArity; i++) {
-        aggregatedLongestExpressionLength += (from s in grammar.GetAllowedSymbols(symbol, i)
-                                              select grammar.GetMaxExpressionLength(s)).Max();
+        aggregatedLongestExpressionLength += (from s in node.GetAllowedSymbols(i)
+                                              select node.Grammar.GetMaxExpressionLength(s)).Max();
         if (aggregatedLongestExpressionLength < targetSize) minArity = i;
         else break;
@@ -163,6 +298,6 @@
       long aggregatedShortestExpressionLength = 0;
       for (int i = 0; i < maxArity; i++) {
-        aggregatedShortestExpressionLength += (from s in grammar.GetAllowedSymbols(symbol, i)
-                                               select grammar.GetMinExpressionLength(s)).Min();
+        aggregatedShortestExpressionLength += (from s in node.GetAllowedSymbols(i)
+                                               select node.Grammar.GetMinExpressionLength(s)).Min();
         if (aggregatedShortestExpressionLength > targetSize) {
           maxArity = i;
@@ -173,18 +308,4 @@
       return random.Next(minArity, maxArity + 1);
     }
-
-    private static SymbolicExpressionTreeNode CreateMinimalTree(IRandom random, ISymbolicExpressionGrammar grammar, IEnumerable<Symbol> symbols) {
-      // determine possible symbols that will lead to the smallest possible tree
-      var possibleSymbols = (from s in symbols
-                             group s by grammar.GetMinExpressionLength(s) into g
-                             orderby g.Key
-                             select g).First();
-      var selectedSymbol = SelectRandomSymbol(random, possibleSymbols);
-      // build minimal tree by recursive application
-      var tree = selectedSymbol.CreateTreeNode();
-      for (int i = 0; i < grammar.GetMinSubTreeCount(selectedSymbol); i++)
-        tree.AddSubTree(CreateMinimalTree(random, grammar, grammar.GetAllowedSymbols(selectedSymbol, i)));
-      return tree;
-    }
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Crossovers/SubtreeCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Crossovers/SubtreeCrossover.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Crossovers/SubtreeCrossover.cs	(revision 3338)
@@ -49,11 +49,11 @@
     }
 
-    protected override SymbolicExpressionTree Cross(IRandom random, ISymbolicExpressionGrammar grammar,
+    protected override SymbolicExpressionTree Cross(IRandom random,
       SymbolicExpressionTree parent0, SymbolicExpressionTree parent1,
       IntValue maxTreeSize, IntValue maxTreeHeight, out bool success) {
-      return Cross(random, grammar, parent0, parent1, InternalCrossoverPointProbabilityParameter.ActualValue.Value, maxTreeSize.Value, maxTreeHeight.Value, out success);
+      return Cross(random, parent0, parent1, InternalCrossoverPointProbabilityParameter.ActualValue.Value, maxTreeSize.Value, maxTreeHeight.Value, out success);
     }
 
-    public static SymbolicExpressionTree Cross(IRandom random, ISymbolicExpressionGrammar grammar,
+    public static SymbolicExpressionTree Cross(IRandom random,
       SymbolicExpressionTree parent0, SymbolicExpressionTree parent1,
       double internalCrossoverPointProbability, int maxTreeSize, int maxTreeHeight, out bool success) {
@@ -67,9 +67,9 @@
       int maxInsertedBranchHeight = maxTreeHeight - GetBranchLevel(parent0.Root, crossoverPoint0);
 
-      var allowedBranches = from branch in IterateNodes(parent1.Root)
+      var allowedBranches = from branch in parent1.Root.IterateNodesPrefix()
                             where branch.GetSize() < maxInsertedBranchSize
                             where branch.GetHeight() < maxInsertedBranchHeight
-                            where grammar.GetAllowedSymbols(crossoverPoint0.Symbol, replacedSubtreeIndex).Contains(branch.Symbol)
-                            where IsMatchingPointType(parent0, crossoverPoint0, branch)
+                            // where crossoverPoint0.GetAllowedSymbols(replacedSubtreeIndex).Contains(branch.Symbol)
+                            where IsMatchingPointType(crossoverPoint0, replacedSubtreeIndex, branch)
                             select branch;
 
@@ -89,33 +89,35 @@
     }
 
-    private static bool IsMatchingPointType(SymbolicExpressionTree tree, SymbolicExpressionTreeNode parent, SymbolicExpressionTreeNode newBranch) {
-      var functionCalls = (from node in IterateNodes(newBranch)
-                           let invokeNode = node as InvokeFunctionTreeNode
-                           let argNode = node as ArgumentTreeNode
-                           where invokeNode != null || argNode != null
-                           let name = invokeNode != null ? invokeNode.InvokedFunctionName : "ARG" + argNode.ArgumentIndex
-                           let argCount = invokeNode != null ? invokeNode.SubTrees.Count : 0
-                           select new { FunctionName = name, FunctionArgumentCount = argCount }).Distinct();
-      var definingBranch = GetDefiningBranch(tree, parent);
-      if (definingBranch == null) return false;
-      foreach (var functionCall in functionCalls) {
-        if (!definingBranch.DynamicSymbols.Contains(functionCall.FunctionName) ||
-          definingBranch.GetDynamicSymbolArgumentCount(functionCall.FunctionName) != functionCall.FunctionArgumentCount)
-          return false;
+    private static bool IsMatchingPointType(SymbolicExpressionTreeNode parent, int replacedSubtreeIndex, SymbolicExpressionTreeNode branch) {
+      // cannot compare dynamic symbols by reference because new instances of Invoke/Argument are created on demand
+      // instead we must check equality by names and number of arguments 
+      var branchSymbols = (from node in branch.IterateNodesPrefix()
+                           select new { FunctionName = node.Symbol.Name, SubtreeCount = node.SubTrees.Count }).Distinct();
+
+      // check syntax constraints of direct parent - child relation
+      var matchingSymbolInParentGrammar = (from sym in parent.GetAllowedSymbols(replacedSubtreeIndex)
+                                           where sym.Name == branch.Symbol.Name
+                                           select sym).SingleOrDefault();
+      if (matchingSymbolInParentGrammar == null ||
+        branch.SubTrees.Count < parent.Grammar.GetMinSubtreeCount(matchingSymbolInParentGrammar) ||
+        branch.SubTrees.Count > parent.Grammar.GetMaxSubtreeCount(matchingSymbolInParentGrammar)) return false;
+
+      // check point type for the whole branch
+      foreach (var branchSymbol in branchSymbols) {
+        matchingSymbolInParentGrammar = (from sym in parent.Grammar.Symbols
+                                         where sym.Name == branchSymbol.FunctionName
+                                         select sym).SingleOrDefault();
+        if (matchingSymbolInParentGrammar == null ||
+          branchSymbol.SubtreeCount < parent.Grammar.GetMinSubtreeCount(matchingSymbolInParentGrammar) ||
+          branchSymbol.SubtreeCount > parent.Grammar.GetMaxSubtreeCount(matchingSymbolInParentGrammar)) return false;
       }
+
       return true;
     }
 
-    private static SymbolicExpressionTreeNode GetDefiningBranch(SymbolicExpressionTree tree, SymbolicExpressionTreeNode parent) {
-      foreach (var treeNode in tree.Root.SubTrees) {
-        if (IterateNodes(treeNode).Contains(parent)) return treeNode;
-      }
-      return null;
-    }
-
     private static void SelectCrossoverPoint(IRandom random, SymbolicExpressionTree parent0, double internalNodeProbability, out SymbolicExpressionTreeNode crossoverPoint, out int subtreeIndex) {
-      var crossoverPoints = from branch in IterateNodes(parent0.Root)
+      var crossoverPoints = from branch in parent0.Root.IterateNodesPrefix()
                             where branch.SubTrees.Count > 0
-                            where !(branch.Symbol is ProgramRootSymbol)
+                            where branch != parent0.Root
                             from index in Enumerable.Range(0, branch.SubTrees.Count)
                             let p = new { CrossoverPoint = branch, SubtreeIndex = index, IsLeaf = branch.SubTrees[index].SubTrees.Count == 0 }
@@ -172,13 +174,4 @@
     }
 
-    private static IEnumerable<SymbolicExpressionTreeNode> IterateNodes(SymbolicExpressionTreeNode root) {
-      foreach (var subTree in root.SubTrees) {
-        foreach (var branch in IterateNodes(subTree)) {
-          yield return branch;
-        }
-      }
-      yield return root;
-    }
-
     private static int GetBranchLevel(SymbolicExpressionTreeNode root, SymbolicExpressionTreeNode point) {
       if (root == point) return 0;
